/*	$NetBSD$	*/

/*
 * Copyright (c) 2000 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Kazuki Sakamoto <sakamoto@netbsd.org>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *        This product includes software developed by the NetBSD
 *        Foundation, Inc. and its contributors.
 * 4. Neither the name of The NetBSD Foundation nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * YMF724/740/744/754 registers
 */

#ifndef _DEV_PCI_YMFREG_H_
#define	_DEV_PCI_YMFREG_H_

/*
 * PCI Config Registers
 */
#define	YMF_PCI_MBA		0x10
#define	YMF_PCI_LEGACY		0x40
# define YMF_PCI_LEGACY_SBEN	0x0001
# define YMF_PCI_LEGACY_FMEN	0x0002
# define YMF_PCI_LEGACY_JPEN	0x0004
# define YMF_PCI_LEGACY_MEN	0x0008
# define YMF_PCI_LEGACY_MIEN	0x0010
# define YMF_PCI_LEGACY_IO	0x0020
# define YMF_PCI_LEGACY_SDMA0	0x0000
# define YMF_PCI_LEGACY_SDMA1	0x0040
# define YMF_PCI_LEGACY_SDMA3	0x00c0
# define YMF_PCI_LEGACY_SBIRQ5	0x0000
# define YMF_PCI_LEGACY_SBIRQ7	0x0100
# define YMF_PCI_LEGACY_SBIRQ9	0x0200
# define YMF_PCI_LEGACY_SBIRQ10	0x0300
# define YMF_PCI_LEGACY_SBIRQ11	0x0400
# define YMF_PCI_LEGACY_MPUIRQ5	0x0000
# define YMF_PCI_LEGACY_MPUIRQ7	0x0800
# define YMF_PCI_LEGACY_MPUIRQ9	0x1000
# define YMF_PCI_LEGACY_MPUIRQ10 0x1800
# define YMF_PCI_LEGACY_MPUIRQ11 0x2000
# define YMF_PCI_LEGACY_SIEN	0x4000
# define YMF_PCI_LEGACY_LAD	0x8000

# define YMF_PCI_EX_LEGACY_FMIO_388	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_FMIO_398	(0x0001 << 16)
# define YMF_PCI_EX_LEGACY_FMIO_3A0	(0x0002 << 16)
# define YMF_PCI_EX_LEGACY_FMIO_3A8	(0x0003 << 16)
# define YMF_PCI_EX_LEGACY_SBIO_220	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_SBIO_240	(0x0004 << 16)
# define YMF_PCI_EX_LEGACY_SBIO_260	(0x0008 << 16)
# define YMF_PCI_EX_LEGACY_SBIO_280	(0x000c << 16)
# define YMF_PCI_EX_LEGACY_MPUIO_330	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_MPUIO_300	(0x0010 << 16)
# define YMF_PCI_EX_LEGACY_MPUIO_332	(0x0020 << 16)
# define YMF_PCI_EX_LEGACY_MPUIO_334	(0x0030 << 16)
# define YMF_PCI_EX_LEGACY_JSIO_201	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_JSIO_202	(0x0040 << 16)
# define YMF_PCI_EX_LEGACY_JSIO_204	(0x0080 << 16)
# define YMF_PCI_EX_LEGACY_JSIO_205	(0x00c0 << 16)
# define YMF_PCI_EX_LEGACY_MAIM		(0x0100 << 16)
# define YMF_PCI_EX_LEGACY_SBMOD_PCI	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_SBMOD_DDMA	(0x1000 << 16)
# define YMF_PCI_EX_LEGACY_SBVER_3	(0x0000 << 16)
# define YMF_PCI_EX_LEGACY_SBVER_2	(0x2000 << 16)
# define YMF_PCI_EX_LEGACY_SBVER_1	(0x4000 << 16)
# define YMF_PCI_EX_LEGACY_IMOD		(0x8000 << 16)

#define	YMF_PCI_DSCTRL		0x48
# define YMF_DSCTRL_CRST	0x00000001
# define YMF_DSCTRL_WRST	0x00000004

#define YMF_PCI_FM_BA		0x60
#define YMF_PCI_SB_BA		0x62
#define YMF_PCI_MPU_BA		0x64
#define YMF_PCI_JS_BA		0x66

/*
 * YMF registers
 */
#define YMF_INTERRUPT_FLAGS	0x0004
#define YMF_INTERRUPT_FLAGS_TI	0x0001
#define YMF_ACTIVITY		0x0006
# define YMF_ACTIVITY_DOCKA	0x0010
#define	YMF_GLOBAL_CONTROL	0x0008
# define YMF_GLCTRL_HVE		0x0001
# define YMF_GLCTRL_HVIE	0x0002

#define YMF_GPIO_IIF		0x0050
# define YMF_GPIO_GIO0		0x0001
# define YMF_GPIO_GIO1		0x0002
# define YMF_GPIO_GIO2		0x0004
#define YMF_GPIO_IIE		0x0052
# define YMF_GPIO_GIE0		0x0001
# define YMF_GPIO_GIE1		0x0002
# define YMF_GPIO_GIE2		0x0004
#define YMF_GPIO_ISTAT		0x0054
# define YMF_GPIO_GPI0		0x0001
# define YMF_GPIO_GPI1		0x0002
# define YMF_GPIO_GPI2		0x0004
#define YMF_GPIO_OCTRL		0x0056
# define YMF_GPIO_GPO0		0x0001
# define YMF_GPIO_GPO1		0x0002
# define YMF_GPIO_GPO2		0x0004
#define YMF_GPIO_FUNCE		0x0058
# define YMF_GPIO_GPC0		0x0001
# define YMF_GPIO_GPC1		0x0002
# define YMF_GPIO_GPC2		0x0004
# define YMF_GPIO_GPE0		0x0010
# define YMF_GPIO_GPE1		0x0020
# define YMF_GPIO_GPE2		0x0040
#define YMF_GPIO_ITYPE		0x005a
# define YMF_GPIO_GPT0_LEVEL	0x0000
# define YMF_GPIO_GPT0_RISE	0x0001
# define YMF_GPIO_GPT0_FALL	0x0002
# define YMF_GPIO_GPT0_BOTH	0x0003
# define YMF_GPIO_GPT0_MASK	0x0003
# define YMF_GPIO_GPT1_LEVEL	0x0004
# define YMF_GPIO_GPT1_RISE	0x0005
# define YMF_GPIO_GPT1_FALL	0x0006
# define YMF_GPIO_GPT1_BOTH	0x0007
# define YMF_GPIO_GPT1_MASK	0x0007
# define YMF_GPIO_GPT2_LEVEL	0x0000
# define YMF_GPIO_GPT2_RISE	0x0010
# define YMF_GPIO_GPT2_FALL	0x0020
# define YMF_GPIO_GPT2_BOTH	0x0030
# define YMF_GPIO_GPT2_MASK	0x0030

#define	YMF_GLOBAL_CONTROL	0x0008
# define YMF_GLCTRL_HVE		0x0001
# define YMF_GLCTRL_HVIE	0x0002

#define	AC97_CMD_DATA		0x0060
#define	AC97_CMD_ADDR		0x0062
# define AC97_ID(id)		((id) << 8)
# define AC97_CMD_READ		0x8000
# define AC97_CMD_WRITE		0x0000
#define	AC97_STAT_DATA1		0x0064
#define	AC97_STAT_ADDR1		0x0066
#define	AC97_STAT_DATA2		0x0068
#define	AC97_STAT_ADDR2		0x006a
# define AC97_BUSY		0x8000

#define	YMF_LEGACY_OUT_VOLUME	0x0080
#define	YMF_DAC_OUT_VOLUME	0x0084
#define	YMF_DAC_OUT_VOL_L	0x0084
#define	YMF_DAC_OUT_VOL_R	0x0086
#define	YMF_ZV_OUT_VOLUME	0x0088
#define	YMF_2ND_OUT_VOLUME	0x008C
#define	YMF_ADC_OUT_VOLUME	0x0090
#define	YMF_LEGACY_REC_VOLUME	0x0094
#define	YMF_DAC_REC_VOLUME	0x0098
#define	YMF_ZV_REC_VOLUME	0x009C
#define	YMF_2ND_REC_VOLUME	0x00A0
#define	YMF_ADC_REC_VOLUME	0x00A4
#define	YMF_ADC_IN_VOLUME	0x00A8
#define	YMF_REC_IN_VOLUME	0x00AC
#define	YMF_P44_OUT_VOLUME	0x00B0
#define	YMF_P44_REC_VOLUME	0x00B4
#define	YMF_SPDIFIN_OUT_VOLUME	0x00B8
#define	YMF_SPDIFIN_REC_VOLUME	0x00BC

#define	YMF_ADC_SAMPLE_RATE	0x00c0
#define	YMF_REC_SAMPLE_RATE	0x00c4
#define	YMF_ADC_FORMAT		0x00c8
#define	YMF_REC_FORMAT		0x00cc
# define YMF_FORMAT_8BIT	0x01
# define YMF_FORMAT_STEREO	0x02

#define	YMF_STATUS		0x0100
# define YMF_STAT_ACT		0x00000001
# define YMF_STAT_WORK		0x00000002
# define YMF_STAT_TINT		0x00008000
# define YMF_STAT_INT		0x80000000
#define	YMF_CONTROL_SELECT	0x0104
# define YMF_CSEL		0x00000001
#define	YMF_MODE		0x0108
# define YMF_MODE_ACTV		0x00000001
# define YMF_MODE_ACTV2		0x00000002
# define YMF_MODE_TOUT		0x00008000
# define YMF_MODE_RESET		0x00010000
# define YMF_MODE_AC3		0x40000000
# define YMF_MODE_MUTE		0x80000000

#define	YMF_CONFIG		0x0114
# define YMF_DSP_DISABLE	0
# define YMF_DSP_SETUP		0x00000001

#define	YMF_PLAY_CTRLSIZE	0x0140
#define	YMF_REC_CTRLSIZE	0x0144
#define	YMF_EFFECT_CTRLSIZE	0x0148
#define	YMF_WORK_SIZE		0x014c
#define	YMF_MAPOF_REC		0x0150
# define YMF_RECSLOT_VALID	0x00000001
# define YMF_ADCSLOT_VALID	0x00000002
#define	YMF_MAPOF_EFFECT	0x0154
# define YMF_DL_VALID		0x00000001
# define YMF_DR_VALID		0x00000002
# define YMF_EFFECT1_VALID	0x00000004
# define YMF_EFFECT2_VALID	0x00000008
# define YMF_EFFECT3_VALID	0x00000010

#define	YMF_PLAY_CTRLBASE	0x0158
#define	YMF_REC_CTRLBASE	0x015c
#define	YMF_EFFECT_CTRLBASE	0x0160
#define	YMF_WORK_BASE		0x0164

#define	YMF_DSP_INSTRAM		0x1000
#define	YMF_CTRL_INSTRAM	0x4000

typedef enum {
	YMF_DS_1,
	YMF_DS_1E
} ymf_dstype_t;

#define	AC97_TIMEOUT		1000
#define	YMF_WORK_TIMEOUT	250000

/* slot control data structures */
#define	MAX_PLAY_SLOT_CTRL	64
#define	N_PLAY_SLOT_CTRL_BANK	2
#define	N_REC_SLOT_CTRL		2
#define	N_REC_SLOT_CTRL_BANK	2

/*
 * play slot
 */
union play_slot_table {
	u_int32_t numofplay;
	u_int32_t slotbase;
};

struct play_slot_ctrl_bank {
	u_int32_t format;
#define	PSLT_FORMAT_STEREO	0x00010000
#define	PSLT_FORMAT_8BIT	0x80000000
#define	PSLT_FORMAT_SRC441	0x10000000
#define PSLT_FORMAT_RCH		0x00000001
	u_int32_t loopdefault;
	u_int32_t pgbase;
	u_int32_t pgloop;
	u_int32_t pgloopend;
	u_int32_t pgloopfrac;
	u_int32_t pgdeltaend;
	u_int32_t lpfkend;
	u_int32_t eggainend;
	u_int32_t lchgainend;
	u_int32_t rchgainend;
	u_int32_t effect1gainend;
	u_int32_t effect2gainend;
	u_int32_t effect3gainend;
	u_int32_t lpfq;
	u_int32_t status;
#define	PSLT_STATUS_DEND	0x00000001
	volatile u_int32_t numofframes;
	volatile u_int32_t loopcount;
	volatile u_int32_t pgstart;
	volatile u_int32_t pgstartfrac;
	u_int32_t pgdelta;
	u_int32_t lpfk;
	volatile u_int32_t eggain;
	volatile u_int32_t lchgain;
	volatile u_int32_t rchgain;
	volatile u_int32_t effect1gain;
	volatile u_int32_t effect2gain;
	volatile u_int32_t effect3gain;
	volatile u_int32_t lpfd1;
	volatile u_int32_t lpfd2;
};

/*
 * rec slot
 */
struct rec_slot_ctrl_bank {
	u_int32_t pgbase;
	u_int32_t pgloopendadr;
	volatile u_int32_t pgstartadr;
	volatile u_int32_t numofloops;
};

struct rec_slot {
	struct rec_slot_ctrl {
		struct rec_slot_ctrl_bank bank[N_REC_SLOT_CTRL_BANK];
	} ctrl[N_REC_SLOT_CTRL];
};

/*
 * effect slot
 */
struct effect_slot_ctrl_bank {
	u_int32_t pgbase;
	u_int32_t pgloopend;
	volatile u_int32_t pgstart;
	volatile u_int32_t temp;
};

#endif /* _DEV_PCI_YMFREG_H_ */
